// =========================================================
// CBP_2403_R_Arc_PID
// 10-10-21
// From CBP_FBO ServoTest_0A 21-05-21
// Moves forward along arc of specified angle and radius
// =========================================================

#include <Servo.h>                           

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 19
#define EncoderR_pin 20

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0
#define dx ((PI*wheelDiam)/64.0)

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

// Variables for this activity
volatile unsigned long countL = 0;
volatile unsigned long countR = 0;

float fwdL,fwdR;
float dist;
unsigned long nL,nR;
float nLf, nRf;
float error;
float deriv;
float lastError = 0.0;
float Kp;
float Kd;

float desTheta;
float desDegrees;
float desRadius;

void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n"); 
 // servoL.attach(ServoL_pin);                         
 // servoR.attach(ServoR_pin);  
 // driveServos(0.0,0.0);

  pinMode(EncoderL_pin,INPUT);
  pinMode(EncoderR_pin,INPUT);
  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISRoutineL,CHANGE);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISRoutineR,CHANGE);
  
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");

  // Calculate the parameters ------------------------------
  // Set your desired arc radius and angle
  // desRadius = 
  // desDegrees = 
  desTheta = desDegrees*(PI/180.0);

  // Calculate the steps (as floats) -------------------
  // nLf =
  // nRf =

  // Calculate the motor speeds ------------------------
  fwdL = 20;
  // fwdR = 

  cprintf("DesDegrees = %f, desRadius = %f, nLf = %f, nRf = %f\n",
          desDegrees, desRadius, nRf, nLf);
  cprintf("fwdL = %f, fwdR = %f\n",fwdL,fwdR);
            
  // Need to avoid nan when calc error
  countL = 1;
  countR = 1;
  
  nL = (unsigned long) nLf;
  nR = (unsigned long) nRf;

  // These values work fine
  Kp = 80;
  Kd = 0;

  cprintf(">>> Delaying 4 secs\n");
  delay(4000);
  if(DEBUG)
	  cprintf("nL = %l, nR = %l\n",nL,nR);
  cprintf(">>> Attaching servos ....................\n");
             
  servoL.attach(ServoL_pin);                         
  servoR.attach(ServoR_pin);  
  driveServos(0.0,0.0);            

}

// the loop function runs over and over again forever
void loop() {

  // Calculate the error ---------------------------
  // error =
  deriv = error - lastError;
  lastError = error;
  
  driveL = fwdL - Kp*error - Kd*deriv;
  driveR = fwdR + Kp*error + Kd*deriv; 
    
  if( (countL > nL) && (countR > nR)){
    driveL = 0;
    driveL = 0;
    detachServos();
  }
      
  cprintf("error = %f, driveL = %f, driveR = %f\n",error,driveL,driveR);
  driveServos(driveL,driveR);
  delay(20);
  
}

void ISRoutineL() {
  countL++;
}

void ISRoutineR() {
  countR++;
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}

void detachServos() {
  servoL.detach();
  servoR.detach();
}
