// ========================================================
//
// CBP_2403_R_Forward_Calibrate
// Moving forward with some basic math calcs
// CBP 15-09-21 
// Status Release
//
// ========================================================

#include <stdio.h>
#include <Servo.h>

// Define pins ---------------
#define HC_SR04_Tx 2
#define HC_SR04_Rx 3
#define ServoL_pin 13
#define ServoR_pin 12

// Define constants ----------
#define dT 20
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;
float dist;

void setup() {

  // Local variables
  float desDist;
  float desSpeed;
  float desTime;
  float omega;
  float rpm;
  int delayTime;
  
  Serial.begin(9600);
  Serial.println(">>> Initializing stuff ..................\n");  
  delay(1000);
  pinMode(HC_SR04_Tx,OUTPUT);
  pinMode(HC_SR04_Rx,INPUT);
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);
  // Stop any servo movement
  driveServos(0.0,0.0);  

  // Start writing your code here --------------------------
  // Follow the worksheet flowchart
  









  // End of your code. The last thing would be -------------
  // setting driveL and driveR
  
  cprintf("desDist = %f, desTime = %f\n",desDist,desTime);
  cprintf("desSpeed = %f (mm/s), omega = %f (rad/s) rpm = %f driveL = %f\n",desSpeed,omega,rpm,driveL);
  
  //Serial.println("Pausing 2 secs ......................");
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");

  // Apply driveL and driveR for desTime
  driveServos(driveL,driveR);

  delayTime = (int)(desTime*1000);
  cprintf("DelayTime = %d\n",delayTime);
  delay(delayTime);

  // Stop any servo movement
  driveServos(0.0,0.0);  
  
}

void loop() {

}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 - (int)_driveL);
  servoR.writeMicroseconds(1500 + (int)_driveR);
}
