// ========================================================
//
// CBP_2403_R_HCSR04_Investigation
// Looks at getting the USonic sensor to work!
// Need 60 ms delay (datasheet)
// Catch 'bad' values and report as -1
// CBP 15-09-21 
// Status Release
//
// ========================================================

#include <stdio.h>
#include <Servo.h>

// Define pins ---------------
#define HC_SR04_Tx 2
#define HC_SR04_Rx 3
#define ServoL_pin 13
#define ServoR_pin 12

// Define constants ----------
#define dT 20
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0


// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;
float dist;

void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n");
  pinMode(HC_SR04_Tx,OUTPUT);
  pinMode(HC_SR04_Rx,INPUT);
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);
  // Stop any servo movement
  driveServos(0.0,0.0);  
  
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");

}

void loop() {
  int delayVal;
  // delay of 60 ms required by datasheet
  delayVal = 60;
  dist = getDistance();
  delay(delayVal);
 
}

float getDistance() {
  long duration;
  float mm;
  // Put the digitalWrite to make the pulse here ----------


  // Now get the pulse duration and convert to mm ---------


  
  // Catch 'bad' values and report as mm = -1; ------------


  //Print out the duration and the distance in mm ---------


  return mm;
  
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 - (int)_driveL);
  servoR.writeMicroseconds(1500 + (int)_driveR);
}
