// ========================================================
//
// CBP_2403_R_LineSensor_Test.ino
// 27-09-21
//
// Based on FBO_CBP_Line_Follower.ino
// FBO CBP 30-03-21
// For line following using Parallax kit
//
// ========================================================

#include <Servo.h>                           

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

// Globals for this task
float error;
float Kp;
int fwd;
long senseL, senseR;

void setup(){
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n");
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);
  // Stop any servo movement
  driveServos(0.0,0.0);  
  Kp=40.0;
}

// This code repeats indefinitely
void loop() {
  // Add your code here ------------------------------------
  



  delay(250);                        
}

long RCTime(int sensorIn){
   long duration = 0;
   pinMode(sensorIn, OUTPUT);     // Make pin OUTPUT
   digitalWrite(sensorIn, HIGH);  // Pin HIGH (discharge capacitor)
   delay(1);                      // Wait 1ms
   pinMode(sensorIn, INPUT);      // Make pin INPUT
   digitalWrite(sensorIn, LOW);   // Turn off internal pullups
   while(digitalRead(sensorIn)){  // Wait for pin to go LOW
      duration++;
   }
   return duration;
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
