// =========================================================
// CBP_2403_R_StLine_PID
// 10-10-21
// From CBP_FBO StLine_Naieve 31-05-21
// Moves forward specified dist using ticks
// =========================================================

#include <Servo.h>                           

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 19
#define EncoderR_pin 20

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0
#define dx ((PI*wheelDiam)/64.0)

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

// Variables for this activity
volatile unsigned long countL = 0;
volatile unsigned long countR = 0;

float drive;
float desiredDist;
unsigned long nL,nR;
float nLf, nRf;
float error;
float deriv;
float lastError = 0.0;
float Kp;
float Kd;

void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n"); 

  pinMode(EncoderL_pin,INPUT);
  pinMode(EncoderR_pin,INPUT);
  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISRoutineL,CHANGE);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISRoutineR,CHANGE);
  
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");

  // Need to avoid nan when calc error
  countL = 1;
  countR = 1;
  
  drive = 20;

  desiredDist= 300;
  nLf = desiredDist/dx;
  nRf = desiredDist/dx;
  nL = (unsigned long) nLf;
  nR = (unsigned long) nRf;

  // These values work fine
  Kp = 80;
  Kd = 50;
  
  if(DEBUG)
	  cprintf("dx = %f, nLf = %f, nRf = %f,nL = %l, nr = %l\n",
	           dx,nLf,nRf,nL,nR);
  cprintf(">>> Attaching servos ....................\n");
             
  servoL.attach(ServoL_pin);                         
  servoR.attach(ServoR_pin);  
  driveServos(0.0,0.0);            

}

// the loop function runs over and over again forever
void loop() {

  // Calculate the error -----------------------------
  // error = 
  deriv = error - lastError;
  lastError = error;

  // Calculate the drives ----------------------------
  // driveL = 
  // driveR = 

  // Test if we have finished and stop --------
  if( (countL > nL) && (countR > nR)){
    driveL = 0;
    driveL = 0;
    detachServos();
  }
      
  cprintf("error = %f, driveL = %f, driveR = %f\n",error,driveL,driveR);
  driveServos(driveL,driveR);
  delay(20);
  
}

void ISRoutineL() {
  countL++;
}

void ISRoutineR() {
  countR++;
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}

void detachServos() {
  servoL.detach();
  servoR.detach();
}
